#!/usr/bin/env ruby
############################################################################
#    Copyright (C) 2005 by Ian Monroe                                      #
#    ian@monroe.nu                                                         #
#                                                                          #
#    This program is free software; you can redistribute it and#or modify  #
#    it under the terms of the GNU General Public License as published by  #
#    the Free Software Foundation; either version 2 of the License, or     #
#    (at your option) any later version.                                   #
#                                                                          #
#    This program is distributed in the hope that it will be useful,       #
#    but WITHOUT ANY WARRANTY; without even the implied warranty of        #
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         #
#    GNU General Public License for more details.                          #
#                                                                          #
#    You should have received a copy of the GNU General Public License     #
#    along with this program; if not, write to the                         #
#    Free Software Foundation, Inc.,                                       #
#    51 Franklin Steet, Fifth Floor, Boston, MA  02111-1307, USA.             #
############################################################################

#require 'Qt'
#require "#{File.dirname( File.expand_path(__FILE__))}/amarokmms.rb"

require 'gtk2'

require "#{File.dirname( File.expand_path(__FILE__))}/main"
#require 'gui/splash'

require "#{File.dirname( File.expand_path(__FILE__))}/log"
require "#{File.dirname( File.expand_path(__FILE__))}/config"

require "#{File.dirname( File.expand_path(__FILE__))}/amarok"

#a simple method to call DCOP. If you use Korundum, you can use
#dR = KDE::DCOPRef.new("amarok", "player"); dR.artist instead
def dcop (val1, val2 = String.new)
	str =`dcop amarok player #{val1} #{val2}`
	str.chomp! if str != nil
	return str
end




def init
	#init_shutdown	# set up shutdown procedure
	init_amarok		# connect to xmms2
	init_window		# get the window object up and set some params
	#set_signals		# set some signal handlers
	init_layouts	# get the mainwin, eq, and plist widgets up
	init_box		# get the vbox for the layouts up and pack them in
	@win.show_all	# make sure we actually see all the windows :)
	@log.info('RXMMS2 started.')
	#kill_splash
end

def init_amarok
	@log.debug('Initializing Amarok.')
	@amarok = Amarok.new()
        #@xmms = Amarok.new('RXMMS2', @config[:ipcpath] ||
	#	@config[:ipcpath] = "unix:///tmp/xmms-ipc-#{ENV['USER']}")

	#@xmmslog = Xmms2Log.new(@xmms, @log)
	#@done_id = @xmms.register_callback(:playlist, &method(:done)) if(@splash)
end

def init_config
	@config = SimpleConfig.new("#{ENV['HOME']}/.xmms2/clients/rxmms2.conf")
end

def init_log
	path = @config[:logpath] || @config[:logpath] = '/tmp/rxmms2.log'
	overwrite = @config[:logoverwrite] || @config[:logoverwrite] = 'true'
	verbosity = @config[:loglevel] || @config[:loglevel] = 'info'

	if(overwrite.match(/false/i))
		overwrite = false
	else
		overwrite = true
	end

	@log = Log.new(path, overwrite, verbosity.to_sym)
end

def init_window
	@log.debug('Bringing up Gtk+.')
	@win = Gtk::Window.new

	@win.set_title('AmarokXMMS')
	#@win.set_icon(Gdk::Pixbuf.new("#{File.dirname( File.expand_path(__FILE__))}/pixmaps/icon.png"))
	@win.border_width = 0	# no wm borders please
	@win.set_decorated(false)	# no wm titlebars, either
end

def init_layouts
	skin = @config[:skin] || @config[:skin] = 'aeon.saturation'
	@log.debug('Initializing MainWin.')
	@mw = MainWin.new(@win, skin, @amarok, @log)
	#@log.debug('Initializing Equalizer.')
	#@eq = Equalizer.new(@win, skin, @xmms, @log)
	#@log.debug('Initializing Playlist.')
	#@pl = Playlist.new(@win, skin, @config[:playlist_display_format] ||
	#	@config[:playlist_display_format] = '%?(%t){%?(%a){%a - }{}%t}{%f}' +
	#	'%?(%c){ [%c]}{}', @xmms, @log)
	#@pl.set_fallback_encoding(@config[:fallback_encoding] ||
	#	@config[:fallback_encoding] = 'Latin1')
end

def init_box
	box = Gtk::VBox.new(false, 0)

	# Right now, the mainwin, equalizer, and playlist are packed into a VBox;
	# this will probably change, though.
	box.pack_start(@mw.layout, false, false, 0)
	#box.pack_start(@eq.layout, false, false, 0)
	#box.pack_start(@pl.layout, false, false, 0)
	@win.add(box)
end

# def loop_until_idle
# 	while(Gtk.events_pending?)
# 		Gtk.main_iteration
# 	end
# end

#you can remove methods you don't need, they're all here just so that you can see

# class ExampleActions < AmaroKSlots
# 	def initialize(app)
# 		@app = app
#                 # TODO initialisation ici
#                 
#                 Gtk.init(ARGV)	# I have no idea why Gtk likes ARGV, but it does
# 
# 		init_config	# load config values, including log info
# 		init_log	# initialize the log so we can log the startup procedur
# 		init
#         	
#         
#         end
# 	def configure
# 		puts " no configure"
# 	end
# 	def stateChange_empty
# 		puts "empty"
# 	end	
# 	def stateChange_idle
# 		puts "idle"
# 	end
# 	def stateChange_paused
# 		puts "paused"
# 	end
# 	def stateChange_playing
# 		puts "playing"
# 	end
# 	def trackChange
# 		puts "track changed"
# 		puts "Now playing #{dcop('title')} by #{dcop('artist')}"
# 	end
# 	def exit
# 		@app.exit
# 	end
# end
# a = Qt::Application.new(ARGV)
# e = ExampleActions.new(a)
# amaroKCommunication = AmaroKLib.new(a, e)
# Gtk.main
# a.exec()


                Gtk.init(ARGV)	# I have no idea why Gtk likes ARGV, but it does
 
 		init_config	# load config values, including log info
 		init_log	# initialize the log so we can log the startup procedur
 		init

		Gtk.main

# loop do
#     message = gets().chomp()
#     command = /[A-Za-z]*/.match( message ).to_s()
# 
#     case command
#         when "configure"
#             msg  = 'This script does not require any configuration.'
#             `dcop amarok playlist popupMessage "#{msg}"`
#     end
# end

