#!/usr/bin/env ruby

class SimpleConfig
	def initialize(configfile)
		@configfile = configfile

		ret = read
		parse

		return ret
	end

	def read
		@configdata = []

		if(File.file?(@configfile))
			# The config file is read line-by-line into an array.
			File.open(@configfile, 'r') do |file|
				@configdata.push(file.gets.chomp) until(file.eof?)
			end

			return true
		else
			return false
		end
	end

	def write
		unparse
		File.open(@configfile, 'w') do |file|
			@configdata.each do |line|
				file.puts(line)
			end
		end
	end

	def [](key)
		return @config[key]
	end

	def []=(key, value)
		return @config[key] = value
	end

	private

	def parse
		@config = {}

		@configdata.each do |line|
			line.chomp.match(/^(.*?):\s+(.*)/)	# "key: value"
			@config[$1.to_sym] = $2 # convert keys to symbols--they're cooler
		end
	end

	def unparse
		@configdata = []

		@config.sort {|a, b| a.to_s <=> b.to_s}.each do |key, value|
			@configdata.push("#{key}: #{value}")
		end
	end
end
