#!/usr/bin/env ruby

require 'gtk2'

# FAIR WARNING: This is _UGLY_. Everything in here is pending rewrites once
# someone with the Ruby-Gnome2 crew decides to document how to extend
# Gtk::Widget. PLEASE GO LOOK AT ANOTHER SOURCE FILE, THIS IS VERBAL DEATH.

module Common
	def images(images, layout) # take a hash full o' images and a Gtk::Fixed
		images.each_pair do |filename, data| # then load up each image
			data.each_value {|data| put_image(filename, data)}
		end
	end

	# This works like the above, except when a button is pressed, it has a
	# callback, and it changes pixmaps.
	def buttons(buttons, layout)
		buttons.each_pair do |filename, data|
			data.each_value {|data| put_button(filename, data)}
		end
	end

	# Again, like the above two, except this one changes pixmaps with changes in
	# window focus.
	def focusable(focusables, layout, win)
		focusables.each_pair do |filename, data|
			data.each_value {|data| put_focusable(filename, data, win)}
		end
	end

	# This is just here so we can pretend to have a seek bar.
	def hslider(images, layout)
		images.each_pair do |filename, data|
			put_image(filename, data[:groove])
			put_button(filename, data[:slider])
		end
	end

	# Maybe someday we can pretend to have an equalizer and scrollable playlist.
	def vslider
	end

	# This returns the correct capitalization of a filename or nil if it doesn't
	# exist.
	def normalize_filename(filename)
		filename += '*' # The glob won't find anything without a wildcard.

		# The docs say this FNM_CASEFOLD thing shouldn't work, but it does. Shh!
		return Dir.glob(filename, File::FNM_CASEFOLD)[0]
	end

	# Gtk2 pixbuf operations are somewhat retarded. You can't display part of a
	# pixbuf; you have to make a new pixbuf from a larger one instead.
	def get_pixbuf_portion(image, pixbuf, x, y, w, h)
		image.set_pixbuf(Gdk::Pixbuf.new(pixbuf, x, y, w, h)) # *shudder*
	end

	def block_signals(widget, signals, status)
		signals.each do |signal|
			case(status)
				when(true)
					widget.signal_handler_block(signal)
				when(false)
					widget.signal_handler_unblock(signal)
			end
		end
	end

	def put_image(filename, data)
		pixbuf = Gdk::Pixbuf.new(filename)
		# s is for source, d is for destination
		(sx, sy, dx, dy, w, h) = data

		layout.put(
			get_pixbuf_portion(Gtk::Image.new, pixbuf, sx, sy, w, h), dx, dy
		)
	end

	def put_button(filename, data)
		pixbuf = Gdk::Pixbuf.new(filename)
		# s is for source, d is for destination, o is for offset
		(sx, sy, dx, dy, ox, oy, w, h, proc) = data
		image = get_pixbuf_portion(Gtk::Image.new, pixbuf, sx, sy, w, h)
		event = Gtk::EventBox.new.add(image)
		focused = false

		# To make something that acts like a button we need to know where the
		# mouse is and whether or not it's clicked.
		signals = [
			event.signal_connect('enter_notify_event') do
				focused = true

				get_pixbuf_portion(image, pixbuf, sx + ox, sy + oy, w, h)
			end,
			event.signal_connect('leave_notify_event') do
				focused = false

				get_pixbuf_portion(image, pixbuf, sx, sy, w, h)
			end
		]

		block_signals(event, signals, true)
		event.signal_connect('button_press_event') do
			get_pixbuf_portion(image, pixbuf, sx + ox, sy + oy, w, h)
			block_signals(event, signals, false)

			# This makes things work for some strange reason.
			focused = true
		end
		event.signal_connect('button_release_event') do
			get_pixbuf_portion(image, pixbuf, sx, sy, w, h)
			block_signals(event, signals, true)
			proc.call if(proc && focused)
		end
		layout.put(event, dx, dy)
	end

	def put_focusable(filename, data, win)
		pixbuf = Gdk::Pixbuf.new(filename)
		# s is for source, d is for destination, o is for offset
		(sx, sy, dx, dy, ox, oy, w, h) = data
		image = get_pixbuf_portion(Gtk::Image.new, pixbuf, sx, sy, w, h)

		layout.put(image, dx, dy)
		win.signal_connect('focus_in_event') do
			get_pixbuf_portion(
				image, pixbuf, sx, sy, w, h
			)
			layout.show_all
		end
		win.signal_connect('focus_out_event') do
			get_pixbuf_portion(
				image, pixbuf,
				sx + ox, sy + oy, w, h
			)
			layout.show_all
		end
	end

	def wrap_next
		if(@xmms.pos == @xmms.length - 1)
			@xmms.jump(0)
		else
			@xmms.next
		end
	end

	def wrap_prev
		if(@xmms.pos == 0)
			@xmms.jump(@xmms.length - 1)
		else
			@xmms.prev
		end
	end

	def quit
		exit
	end
end
