#!/usr/bin/env ruby

require 'gui/common'
include Common

class Skinfo
	attr_reader :plinfo, :visinfo

	def initialize(skin, log)
		@log = log

		parse_plinfo if(get_plinfo(skin))
		parse_visinfo if(get_visinfo(skin))
	end

	def get_plinfo(skin)
		@plfile = get_info("skins/#{skin}/pLedit.txt")
	end

	def get_visinfo(skin)
		@visfile = get_info("skins/#{skin}/vIscolor.txt")
	end

	def parse_plinfo
		return unless(@plfile)

		@plinfo = {}

		@plfile.each do |line|
			next if(line.match(/\[.*\]/))
			line.match(/^(.*?)=(.*)/)
			@plinfo[$1] = $2
		end
	end

	def parse_visinfo
		# TODO - This is only important when and if I decide to make a Winamp-
		# style visualization.
	end

	private

	def get_info(filename)
		filename = normalize_filename(filename)

		if(filename)
			return read_file(filename)
		else
			return nil
		end
	end

	def read_file(file)
		if(File.file?(file))
			data = []

			# This works the same way as in config.rb; every line is pushed onto
			# an array.
			File.open(file, 'r') do |f|	
				data.push(f.gets.chomp) until(f.eof?)
			end

			return data
		else
			@log.error('File not found: ' + file)

			return false
		end
	end
end
