#!/usr/bin/env ruby

require 'gtk2'

class Splash
	def initialize
		@window = Gtk::Window.new
		layout = Gtk::Fixed.new
		@splash = Gtk::Image.new('pixmaps/splash.png')
		@progress_top = Gtk::ProgressBar.new
		@progress_bot = Gtk::ProgressBar.new

		@progress_top.set_orientation(Gtk::ProgressBar::RIGHT_TO_LEFT)
		@progress_top.set_size_request(@splash.pixbuf.width, 15)
		@progress_bot.set_orientation(Gtk::ProgressBar::LEFT_TO_RIGHT)
		@progress_bot.set_size_request(@splash.pixbuf.width, 15)
		layout.put(@progress_top, 0, 0)
		layout.put(@progress_bot, 0, @splash.pixbuf.height - 15)
		layout.put(@splash, 0, 0)
		@window.add(layout)
		@window.set_window_position(Gtk::Window::POS_CENTER_ALWAYS)
		@window.set_decorated(false)
		@window.show_all
		loop_until_idle
	end

	def set_text(str)
		@progress_top.set_text(str)
		@progress_bot.set_text(str)
	end

	def set_progress(frac)
		@progress_top.set_fraction(frac)
		@progress_bot.set_fraction(frac)
		loop_until_idle
	end

	def done
		@window.hide_all
		@window.unrealize
		loop_until_idle
	end

	private

	def loop_until_idle # Can you guess what this function does?
		begin
			Gtk.main_iteration
		end while Gtk.events_pending?
	end
end
